//
//	test CubicHermiteInterpolant
//
//	UL, Wed Sep  8 18:13:42 MET DST 1999
//
#include <iostream>
#include <vector>

#include "slatec++.h"
#include "common.h"

using namespace std;

int main()
{
	const int N = 5;

	vector<double>	x(N), y(N);
	for (int n=0; n<N; ++n) {
		x[n] = DBL(n);
		y[n] = 0.;
	}

	Slatec::CubicHermiteInterpolant<double> chi(x, y);
//	double xaddv[] = { 1.5, 2., 2.5, 3 },
//		   yaddv[] = { 1.,  1., 1.,  1. };
	double xaddv[] = { -1, 4, 5 },
		   yaddv[] = { 1, 1, 1 };
	vector<double> xadd(xaddv, xaddv+NUM_OF(xaddv)),
				   yadd(yaddv, yaddv+NUM_OF(yaddv));

	chi.replace(xadd, yadd);
	const vector<double> &abs = chi.abscissa();
	for (unsigned n=0; n<abs.size(); ++n)
		cout<<abs[n]<<' '<<chi(abs[n])<<endl;

	return 0;
}

