//
// Giuseppe Vacanti, XMM Science Operations Team -- September 1999
//

//
// FFT a signal back and forth, to see that the process is reversible.
//

#include "slatec++.h"
#include <cmath>
#include <cassert>
#include <vector>
#include <algorithm>

int main() {

  const float eps = 1e-6;
  const unsigned n = 1024;
  const float p = n;

  vector<double> signal(n);
  vector<double> a(n);
  vector<double> b(n);

  double twopi = acos(-1.) * 2;

  // set up signal array
  for(unsigned i = 0; i < n; i++){
    signal[i] = sin(twopi * i / p);
  }

  a = Slatec::forwardFft(signal); // unnormalized
  b = Slatec::backwardFft(a);
  for(unsigned i = 0; i < n; i++){
    assert(fabs(b[i] / n - signal[i]) < eps);
  }    
}
